/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: b_banx.c,v 1.2 1997/09/25 16:56:50 ae59 Exp $ */
/*
$Log: b_banx.c,v $
 * Revision 1.2  1997/09/25  16:56:50  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:21:02  ae59
 * Put under RCS control
 *
 */
/************************************************************************/
/*                                                                      */
/* Descriptive Name : b_banx.x          Processor : C                   */
/*                                                                      */
/* Determine next number of absolute value of non-zero number           */
/*                                                                      */
/* Function value : int     0 - next number returned                    */
/*                      OFLOW - exponent overflow                       */
/*                      ALLOC - allocation error                        */
/*                                                                      */
/* Rounding : none                                                      */
/*                                                                      */
/*      Date            : 1990-07-13                    */
/*      1990-07-13 : LINT_ARGS prototype, Maxl renamed  */
/************************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern a_btyp b_maxl;
#endif

#ifdef LINT_ARGS
local int b_banx(multiprecision i,multiprecision r)
#else
local int b_banx(i,r)

multiprecision i;       /* pointer to intern variable                   */
multiprecision r;       /* pointer to intern result                     */
#endif
        {
        a_intg k;
        a_btyp *s;    /* pointer to result mantissa                   */
/*----------------------------------------------------------------------*/
        if (i==r)                       /* input = output               */
           {
           if (i->l!=b_maxl)            /* input differs from b_maxl    */
              {
                                        /* allocate result mantissa     */
              if (b_ball(b_maxl,&s)) return(ALLOC);
              if (b_maxl<i->l)
                 B_COPY(s,i->m,b_maxl)
              else
                 {
                 for (k=b_maxl-1;k>=i->l;k--) s[k] = ZERO;
                 B_COPY(s,i->m,i->l)
                 }
                                        /* free old mantissa            */
#ifdef HEAP_CHECK
b_freh((a_char *)&i->m,(a_char *)i->m,(a_char *)"b_banx");
#endif
              B_FREE(i->m)
              r->m = s;
              r->l = b_maxl;
              }
                                        /* determine next number        */
           if (b_bcad(b_maxl,r->m))
              {
              if (r->e>MAXINT-1) return(OFLOW);
              else
                 {
                 r->e++;
                 r->m[0] = LSB;
                 }
              }
           }
        else                            /* input differs from output    */
           {
           if (r->l==b_maxl)
              B_CLEAR(r->m,b_maxl)
           else
              {
              if (r->l)
                 {
#ifdef HEAP_CHECK
b_freh((a_char *)&r->m,(a_char *)r->m,(a_char *)"b_banx");
#endif
                 B_FREE(r->m)
                 }
              if (b_ball(b_maxl,&r->m)) return(ALLOC);
              r->l = b_maxl;
              }
           r->e = i->e;
           B_COPY(r->m,i->m, ((b_maxl<i->l) ? b_maxl : i->l) )
           if (b_bcad(b_maxl,r->m))
              {
              if (r->e>MAXINT-1) return(OFLOW);
              else { r->e++; *r->m = 1; }
              }
           }
/*----------------------------------------------------------------------*/
        return(0);
        }
